"""
PearProject - `Decorators`
~~~~~~~~~~~~~~~~~~~
Module avec tout les decorateurs du PearProject !
"""


from functools import wraps
from .errors import *


def type_verifier(func):
    """Vérifie si la valeur du paramètre correspond à son type écrit dans l'annotation.

    Args:
        func (function): La fonction sous le decorateur

    Raises:
        MissingAnnotations: Si les annotations sont mal rentré
        IncorrectParameterType: Si le parametre ne correspond pas a son annotations même après tentative de changement.
    Returns:
        [function]: Retourne la fonction sous le decorateur
    """
    @wraps(func)
    def decorator(*args, **kwargs):
        annotations_list = list(func.__annotations__.values())
        args = list(args)
        print(kwargs)
        if len(args) != len(annotations_list) and len(annotations_list) != 0:
            raise MissingAnnotations
        for i in range(len(annotations_list)):
            if type(args[i]) != annotations_list[i]:
                arg = args[i]
                if annotations_list[i] == None:
                    pass
                elif annotations_list[i] == str:
                    try:
                        args[i] = str(arg)
                    except:
                        raise IncorrectParameterType
                elif annotations_list[i] == int:
                    try:
                        args[i] = int(arg)
                    except:
                        raise IncorrectParameterType
                elif annotations_list[i] == float:
                    try:
                        args[i] = float(arg)
                    except:
                        raise IncorrectParameterType
                elif annotations_list[i] == tuple:
                    try:
                        args[i] = tuple(arg)
                    except:
                        raise IncorrectParameterType
                elif annotations_list[i] == list:
                    try:
                        args[i] = list(arg)
                    except:
                        raise IncorrectParameterType
                elif annotations_list[i] == dict:
                    try:
                        args[i] = dict(arg)
                    except:
                        raise IncorrectParameterType
                else:
                    raise IncorrectParameterType
            args = tuple(args)
        return func(*args, **kwargs)
    return decorator

